function pp=colplot(x,y,c);

%colplot(x,y,c): Fills in areas of colour LIKE PCOLOR SHOULD!!!!
% Use p=colplot(x,y,c)
% x, y are (optional) vectors or matrices giving the location of 
% the center of the cells
% c is the color index at each (x,y)
% Returns one handle per cell in p, ie a big vector.....
% shading flat and faceted work (but not interpolated)



if nargin==1
   c=x;
   [mm nn]=size(c);
   [x y]=meshgrid(1:nn,1:mm);
elseif min(size(x))==1
   [x y]=meshgrid(x,y);
end
[mm nn]=size(c);
mn=mm*nn;
x1=0;x2=0;x3=0;x4=0;y1=0;y2=0;y3=0;y4=0;cv=0;x1v=0;x2v=0;x3v=0;x4v=0;y1v=0;y2v=0;y3v=0;y4v=0;

%x1,x2,x3,x4 are leftbot, rightbot lettop righttop
i=2:mm;j=2:nn;
x1(i,j)=(x(i,j)+x(i,j-1)+x(i-1,j)+x(i-1,j-1))/4;
i=2:mm;j=1:nn-1;
x2(i,j)=(x(i,j)+x(i,j+1)+x(i-1,j)+x(i-1,j+1))/4;
i=1:mm-1;j=2:nn;
x3(i,j)=(x(i,j)+x(i,j-1)+x(i+1,j)+x(i+1,j-1))/4;
i=1:mm-1;j=1:nn-1;
x4(i,j)=(x(i,j)+x(i,j+1)+x(i+1,j)+x(i+1,j+1))/4;

x1(1,1)=x(1,1);
x1(2:mm,1)=(x(2:mm,1)+x(1:mm-1,1))/2;
x1(1,2:nn)=(x(1,2:nn)+x(1,1:nn-1))/2;

x2(1,nn)=x(1,nn);
x2(2:mm,nn)=(x(2:mm,nn)+x(1:mm-1,nn))/2;
x2(1,1:nn-1)=(x(1,1:nn-1)+x(1,2:nn))/2;

x3(mm,1)=x(mm,1);
x3(1:mm-1,1)=(x(1:mm-1,1)+x(2:mm,1))/2;
x3(mm,2:nn)=(x(mm,2:nn)+x(mm,1:nn-1))/2;

x4(mm,nn)=x(mm,nn);
x4(1:mm-1,nn)=(x(1:mm-1,nn)+x(2:mm,nn))/2;
x4(mm,1:nn-1)=(x(mm,1:nn-1)+x(mm,2:nn))/2;

%y1,y2,y3,y4 are leftbot, rightbot lettop righttop
i=2:mm;j=2:nn;
y1(i,j)=(y(i,j)+y(i,j-1)+y(i-1,j)+y(i-1,j-1))/4;
i=2:mm;j=1:nn-1;
y2(i,j)=(y(i,j)+y(i,j+1)+y(i-1,j)+y(i-1,j+1))/4;
i=1:mm-1;j=2:nn;
y3(i,j)=(y(i,j)+y(i,j-1)+y(i+1,j)+y(i+1,j-1))/4;
i=1:mm-1;j=1:nn-1;
y4(i,j)=(y(i,j)+y(i,j+1)+y(i+1,j)+y(i+1,j+1))/4;

y1(1,1)=y(1,1);
y1(2:mm,1)=(y(2:mm,1)+y(1:mm-1,1))/2;
y1(1,2:nn)=(y(1,2:nn)+y(1,1:nn-1))/2;

y2(1,nn)=y(1,nn);
y2(2:mm,nn)=(y(2:mm,nn)+y(1:mm-1,nn))/2;
y2(1,1:nn-1)=(y(1,1:nn-1)+y(1,2:nn))/2;

y3(mm,1)=y(mm,1);
y3(1:mm-1,1)=(y(1:mm-1,1)+y(2:mm,1))/2;
y3(mm,2:nn)=(y(mm,2:nn)+y(mm,1:nn-1))/2;

y4(mm,nn)=y(mm,nn);
y4(1:mm-1,nn)=(y(1:mm-1,nn)+y(2:mm,nn))/2;
y4(mm,1:nn-1)=(y(mm,1:nn-1)+y(mm,2:nn))/2;

%put everything into vector form....

cv(1:mn)=c(1:mn);
x1v(1:mn)=x1(1:mn);
x2v(1:mn)=x2(1:mn);
x3v(1:mn)=x3(1:mn);
x4v(1:mn)=x4(1:mn);
y1v(1:mn)=y1(1:mn);
y2v(1:mn)=y2(1:mn);
y3v(1:mn)=y3(1:mn);
y4v(1:mn)=y4(1:mn);

%colour in using patch
p=patch([x1v;x2v;x4v;x3v],[y1v;y2v;y4v;y3v],cv);

if nargout==1
   pp=p;
end


