C vel=mzap(v,maxvar,lonely1,lonely2)

      subroutine mexfunction(nlhs, plhs, nrhs, prhs)

      integer*4 nlhs, nrhs
      integer*4 plhs(*), prhs(*)

      integer*4 m_in, n_in
      integer*4 vp, velp, maxvarp, lonely1p, lonely2p

      m_in = mxgetm(prhs(1))
      n_in = mxgetn(prhs(1))
      
      vp = mxgetpr(prhs(1))
      maxvarp = mxgetpr(prhs(2))
      lonely1p = mxgetpr(prhs(3))
      lonely2p = mxgetpr(prhs(4))

      plhs(1) = mxcreatefull(m_in, n_in, 0)
      
      velp = mxgetpr(plhs(1))

      call mzap(%VAL(velp), %VAL(vp), %VAL(maxvarp), %VAL(lonely1p),
     : %VAL(lonely2p), m_in, n_in)
      
      return
      end

C================main mzap subroutine=========================
      
      subroutine mzap(vel, v, maxvar, lonely1, lonely2, mm, nn)
      IMPLICIT NONE
      integer*4 mm, nn, M, N
      integer*4 i, j, k

      PARAMETER (M=400, N=1600)
      real*8 maxvar, lonely1, lonely2
      real*8 vel(mm, nn), v(mm, nn)

      real*8 mv2, var(M,N), nan
      integer mask1(M,N)
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      mv2=maxvar**2.0

C work out the variance matrix

      IF ((mm.LE.M).AND.(nn.LE.N)) THEN

         DO i=2,mm-1
            DO j=2,nn-1
               var(i,j)=(((v(i,j-1)-v(i,j))**2)+((v(i,j-1)-v(i,j))**2)
     $              +((v(i+1,j-1)-v(i,j))**2)+((v(i-1,j)-v(i,j))**2)
     $              +((v(i+1,j)-v(i,j))**2)+((v(i-1,j+1)-v(i,j))**2)
     $              +((v(i,j+1)-v(i,j))**2)+((v(i+1,j-1)-v(i,j))**2))
     $              /8.0
            ENDDO
         ENDDO
         
         DO i=2,mm-1 
            var(i,nn)=(((v(i-1,nn)-v(i,nn))**2)+((v(i-1,nn-1)-
     :           v(i,nn))**2)+((v(i,nn-1)-v(i,nn))**2)+((v(i+1,nn-1)-
     :           v(i,nn))**2)+((v(i+1,nn)-v(i,nn))**2))/5.0

            var(i,1)=(((v(i-1,1)-v(i,1))**2)+((v(i-1,2)-v(i,1))**2)+
     :           ((v(i,2)-v(i,1))**2)+((v(i+1,2)-v(i,1))**2)+((v(i+1,1
     $           )-v(i,1))**2))/5.0
         ENDDO

         DO j=2,nn-1 
            var(1,j)=(((v(1,j-1)-v(1,j))**2)+((v(2,j-1)-v(1,j))**2)+
     :           ((v(2,j)-v(1,j))**2)+((v(2,j+1)-v(1,j))**2)+((v(1,j+1
     $           )-v(1,j))**2))/5.0

            var(mm,j)=(((v(mm,j-1)-v(mm,j))**2)+((v(mm-1,j-1)-
     :           v(mm,j))**2)+((v(mm-1,j)-v(mm,j))**2)+((v(mm-1,j+1)-
     :           v(mm,j))**2)+((v(mm,j+1)-v(mm,j))**2))/5.0
         ENDDO
         
C     now do the corners - what a pain
         var(1,1)=(((v(2,1)-v(1,1))**2)+((v(1,2)-v(1,1))**2)+
     :        ((v(2,2)-v(1,1))**2))/3.0
         var(mm,1)=(((v(mm-1,1)-v(mm,1))**2)+((v(1,2)-v(mm,1))**2)+
     :        ((v(mm-1,2)-v(mm,1))**2))/3.0
         var(1,nn)=(((v(2,nn)-v(1,nn))**2)+((v(1,nn-1)-v(1,nn))**2)+
     :        ((v(2,nn-1)-v(1,nn))**2))/3.0
         var(mm,nn)=(((v(mm-1,nn)-v(mm,nn))**2)+((v(mm,nn-1)-
     :        v(mm,nn))**2)+((v(mm-1,nn-1)-v(mm,nn))**2))/3.0

C     create the mask, and prepare v, vel for rotated calc
         
         DO i=1,mm
            DO j=1,nn
               IF (var(i,j).LT.mv2) THEN
                  mask1(i,j)=1
               ELSE
                  mask1(i,j)=0
               ENDIF
               vel(i,j)=v(i,j)+15.0
               IF (vel(i,j).GT.15) THEN
                  vel(i,j)=vel(i,j)-30
               ENDIF
            ENDDO
         ENDDO

C     work out the variance matrix for the rotated v

         DO i=2,mm-1
            DO j=2,nn-1
               var(i,j)=(((vel(i,j-1)-vel(i,j))**2)+((vel(i,j-1)-vel(i
     $              ,j))**2)+((vel(i+1,j-1)-vel(i,j))**2)+((vel(i-1,j)
     $              -vel(i,j))**2)+((vel(i+1,j)-vel(i,j))**2)+((vel(i
     $              -1,j+1)-vel(i,j))**2)+((vel(i,j+1)-vel(i,j))**2)
     $              +((vel(i+1,j-1)-vel(i,j))**2))/8.0
            ENDDO
         ENDDO
         
         DO i=2,mm-1 
            var(i,nn)=(((vel(i-1,nn)-vel(i,nn))**2)+((vel(i-1,nn-1)-
     :           vel(i,nn))**2)+((vel(i,nn-1)-vel(i,nn))**2)+((vel(i+1
     $           ,nn-1)-vel(i,nn))**2)+((vel(i+1,nn)-vel(i,nn))**2))/5
     $           .0

            var(i,1)=(((vel(i-1,1)-vel(i,1))**2)+((vel(i-1,2)-vel(i,1)
     $           )**2)+((vel(i,2)-vel(i,1))**2)+ ((vel(i+1,2)-vel(i,1)
     $           )**2)+((vel(i+1,1)-vel(i,1))**2))/5.0
         ENDDO

         DO j=2,nn-1 
            var(1,j)=(((vel(1,j-1)-vel(1,j))**2)+ 
     :           ((vel(2,j-1)-vel(1,j))**2)+
     :           ((vel(2,j)-vel(1,j))**2)+((vel(2,j+1)-vel(1,j))**2)
     :           +((vel(1,j+1)-vel(1,j))**2))/5.0

            var(mm,j)=(((vel(mm,j-1)-vel(mm,j))**2)+((vel(mm-1,j-1)-
     :           vel(mm,j))**2)+((vel(mm-1,j)-vel(mm,j))**2)+((vel(mm
     $           -1,j+1)-vel(mm,j))**2)+((vel(mm,j+1)-vel(mm,j))**2))
     $           /5.0
         ENDDO
         
C     now do the corners - what a pain
         var(1,1)=(((vel(2,1)-vel(1,1))**2)+((vel(1,2)-vel(1,1))**2)+
     :        ((vel(2,2)-vel(1,1))**2))/3.0
         var(mm,1)=(((vel(mm-1,1)-vel(mm,1))**2)
     :        +((vel(1,2)-vel(mm,1))**2)+((vel(mm-1,2)-vel(mm,1))**2))
     $        /3.0
         var(1,nn)=(((vel(2,nn)-vel(1,nn))**2)+ 
     :        ((vel(1,nn-1)-vel(1,nn))**2)+((vel(2,nn-1)-vel(1,nn))**2
     $        ))/3.0
         var(mm,nn)=(((vel(mm-1,nn)-vel(mm,nn))**2)+((vel(mm,nn-1)-
     :        vel(mm,nn))**2)+((vel(mm-1,nn-1)-vel(mm,nn))**2))/3.0

C     create the second mask, and create composite, requiring
C     discontinuity in both velocity fields
         
         DO i=1,mm
            DO j=1,nn
               vel(i,j)=nan
               IF ((var(i,j).LT.mv2).OR.(mask1(i,j).EQ.1)) THEN
                  vel(i,j)=v(i,j)
               ENDIF
            ENDDO
         ENDDO

C     check for lonely points in data sparse regions
         DO i=2,mm-1
            DO j=2,nn-1
               mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN
     :              (vel(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i
     $              ,j+1))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))
     $              +mexIsNaN(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))
     $              +mexIsNaN(vel(i-1,j-1))).GT.lonely1))
            ENDDO
         ENDDO

         i=1
         k=mm
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :           (i,j+1))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))
     $           +mexIsNaN(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))).GT
     $           .(lonely1*5/8)))
            mask1(k,j)=((mexIsNaN(vel(k,j)).EQ.0).AND.((mexIsNaN(vel
     :           (k-1,j))+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))
     $           +mexIsNaN(vel(k,j-1))+mexIsNaN(vel(k-1,j-1))).GT
     $           .(lonely1*5/8)))
         ENDDO

         j=1
         k=nn
         DO i=2,mm-1
            mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :           (i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))
     $           +mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))).GT
     $           .(lonely1*5/8)))
            mask1(i,k)=((mexIsNaN(vel(i,k)).EQ.0).AND.((mexIsNaN(vel
     :           (i-1,k))+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))
     $           +mexIsNaN(vel(i,k-1))+mexIsNaN(vel(i-1,k-1))).GT
     $           .(lonely1*5/8)))
         ENDDO

         DO i=1,mm
            DO j=1,nn
               IF (mask1(i,j).EQ.1) THEN
                  vel(i,j)=nan
               ENDIF
            ENDDO
         ENDDO

         DO i=2,mm-1
            DO j=2,nn-1
               mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel
     :              (i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1
     $              ))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))
     $              +mexIsNaN(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))
     $              +mexIsNaN(vel(i-1,j-1))).LT.lonely2))
            ENDDO
         ENDDO

         i=1
         k=mm
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i,j+1)
     $           )+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))
     $           +mexIsNaN(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))).LT
     $           .(lonely2*5/8)))
            mask1(k,j)=((mexIsNaN(vel(k,j))).AND.((mexIsNaN(vel(k-1,j)
     $           )+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))
     $           +mexIsNaN(vel(k,j-1))+mexIsNaN(vel(k-1,j-1))).LT
     $           .(lonely2*5/8)))
         ENDDO

         k=nn
         j=1
         DO i=2,mm-1
            mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i-1,j)
     $           )+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))
     $           +mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))).LT
     $           .(lonely2*5/8)))
            mask1(i,k)=((mexIsNaN(vel(i,k))).AND.((mexIsNaN(vel(i-1,k)
     $           )+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))
     $           +mexIsNaN(vel(i,k-1))+mexIsNaN(vel(i-1,k-1))).LT
     $           .(lonely2*5/8)))
         ENDDO

         DO i=1,mm
            DO j=1,nn
               IF (mask1(i,j).EQ.1) THEN
                  vel(i,j)=nan
               ENDIF
            ENDDO
         ENDDO

      ELSE                      !mm and/or nn too big

         PRINT*, "input matrix is too large. mm, nn="
         PRINT*, mm,nn
         PRINT*, "M, N="
         PRINT*, M,N
         DO i=1,mm
            DO j=1,nn
               vel(i,j)=v(i,j)
            ENDDO
         ENDDO
         
      ENDIF


      return
      end
      

