%calculates and plots vs,div,w,sf and shr from interpolated doppler data (xr,zr,vr)

load colmap;

more off

%-----------------------------------------------------
X=xr;
Z=zr;
vel=vr;
[mm nn]=size(vel);
dx=xr(2)-xr(1);
dz=zr(2)-zr(1);

hmin=3;  %lowest allowed value is 2 
small=.5;  %degree of smoothing used

%xmin=10;
%xmax=40;
%zmin=0;
%zmax=2.5;

xmin=min(xr);xmax=max(xr);zmin=min(zr);zmax=max(zr);

v=vel;
vmin=-15;vmax=15;
%simple attempt to unfold velocities, assuming range<vf in roi (comment out if not using velocities!)
%v=unfold(v,-20);

%smooth v field, and remove nans from bottom

vs=smooth2(v,small);

%if small~=0
% n=2:(nn-1);
% m=2:mm-1;
%      vs(m,n)=(v(m,n)+small*(v(m-1,n)+v(m+1,n)+v(m-1,n-1)+v(m,n-1)+v(m+1,n-1)+v(m-1,n+1)+v(m,n+1)+v(m+1,n+1)))/(1.+8.*small);
%else
%  vs=v;
%end

%get rid of NaNs from bottom of data
[vs hmin2]=rmnan(vs);
disp(['using hmin=' int2str(hmin)])
disp(['suggest you use hmin=' int2str(hmin2+1)])
hmin=hmin2+1;disp(['using new value of hmin']);
%calculate divergence
div=zeros(size(vr));
m=2:mm-1;
div(m,:)=(vs(m+1,:)-vs(m-1,:))/(2*dx);
div(1,:)=(-vs(3,:)+4*vs(2,:)-3*vs(1,:))/(2*dx);
div(mm,:)=(vs(mm-2,:)-4*vs(mm-1,:)+3*vs(mm,:))/(2*dx);

%calculate vertical velocities (assume desity scale height=8km)
w=zeros(size(vr));
for n=hmin:nn,
 m=1:mm;
 w(m,n)=w(m,n-1)-(div(m,n)/1000.-w(m,n-1)*1.25E-4)*1000.*dz;
end

%calculate streamfunfuction, sf
sf=zeros(size(vr));
m=1:mm;
for n=hmin:nn,
 sf(m,n)=sf(m,n-1)+dz*vs(m,n)*1.2*exp(-Z(n)/8);
end

%calculate vertical shear of vs
shv=zeros(size(vs));
for i=1:mm
shv(i,:)=gradient(vs(i,:),zr);
end

%calculate horizontal shear of w
shw=zeros(size(w));
for i=1:nn
shw(:,i)=(gradient(w(:,i).',xr)).';
end 

%subtract to get vorticity
vort=shv-shw;

disp('finished calculations')
if exist('plotdat')==0
plotdat='y';
end
if plotdat~='n'
%-----------------start plotting things....-----------------------------
clf
subplot(5,1,1),pcolor(xr,zr,vs');
shading flat
colorbar('vert');
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
title(['Tape ',int2str(file),' Raster ',int2str(raster),' Scan ',int2str(scan)...
	,' ',int2str(day),'/',int2str(month),'/',int2str(year)...
        ,' ',int2str(start_hour),':',int2str(start_min),':',int2str(start_sec)...
        ,' Az ',num2str(azim(:,1)-90),' deg']);
 
set(gca,'xticklabels',[]);
set(gca,'YTick',zmin:.5:zmax);
ylabel('vs (m/s)');

%--------------------------------

subplot(5,1,2), pcolor(xr,zr,div');
shading flat
colorbar('vert');
ylabel('div (m/s/km)');
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
set(gca,'xticklabels',[]);
set(gca,'YTick',zmin:.5:zmax);

%--------------------------------
subplot(5,1,3),pcolor(xr,zr,w');
shading flat
colorbar('vert');
ylabel('w (m/s)');
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
set(gca,'xticklabels',[]);
set(gca,'YTick',zmin:.5:zmax);
%---------------------------------
subplot(5,1,4),co=contour(xr,zr,sf',[-40:1:40]);
colorbar('vert');
ylabel('streamfunction');
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
set(gca,'xticklabels',[]);
set(gca,'YTick',zmin:.5:zmax);
%---------------------------------
subplot(5,1,5),pcolor(xr,zr,shv');
shading flat
colorbar('vert');
ylabel('shear (m/s/km)');
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
set(gca,'YTick',zmin:.5:zmax);
xlabel('Distance(km)');
%---------------------------------
set(gcf,'papertype','a4');
set(gcf,'paperorientation','portrait');
set(gcf,'paperposition',[0 0 8.5 11.5]);
end
%---------------------------------
plotdat='y';

