%RHICORRECT: allows clutter/noise in Doppler RHIs to be corrected on screen...
% load the data into the workspace (e.g. use extract), then run
% rhicorrect. The corrected velocity is stored in v.

colormap(jet);
v=v2;  %set v=matrix to correct
[mm nn]=size(v);
vmin=-15;  %default values
vmax=15;
button=1;
saved=0;

%sort out grids etc

angles=elev(1:nn)';
X=range'*cos(angles'*pi/180);
Z=range'*sin(angles'*pi/180);

%simple attempt to unfold velocities, assuming range<vf in roi (use 1==0 if not using velocities)
%v=unfold2(v2,-10,0,72);
%vf=30;

xmin=10;
xmax=20;
zmin=0;
zmax=3;

xrange=xmax-xmin;
zrange=zmax-zmin;

%which way was the scan done??
if angles(nn)>angles(1);
  scandir=+1;
else
  scandir=-1;
end
%Display source data
clf;
axis([xmin xmax zmin zmax]);
hold on;
title(['Left button deletes. Right updates/fills in. Middle exits. Click outside axes to move']);
pcolor(X,Z,v);
caxis([vmin vmax]);
set(gca,'TickDir','out');
hold off;

%start correcting..

while button~=2

    [x,z,button]=ginput(1);

    r=(x^2+z^2)^0.5;
    el=atan(z/x)*180/pi;

    if (z>zmin)&(z<zmax)&(x>xmin)&(x<xmax),    

    if el<=max(elev)

    m=find(range<=r);
    m1=max(m);

    n=find(angles<=el);
    n1=(scandir==1)*max(n)+(scandir==-1)*(min(n)-1);

    if button==1
      v(m1,n1)=NaN;
      saved=saved+1;
      msave(saved)=m1;
      nsave(saved)=n1;
    end

    if button==3
    for l=1:saved
      m1=msave(l);
      n1=nsave(l);
      count=0;
      total=0;
      for i=(m1-1):(m1+1)
      for j=(n1-1):(n1+1)
        if (i>=1)&(i<=mm)&(j>=1)&(j<=nn)
          if (isnan(v(i,j))==0)
          count=count+1;
          total=total+v(i,j);
          end
        end
      end
      end
      v(m1,n1)=total/count;
    end
    saved=0;
%Display source data
clf;
axis([xmin xmax zmin zmax]);
hold on;
title(['Left button deletes. Right updates/fills in. Middle exits. Click outside axes to move']);
pcolor(X,Z,v);
caxis([vmin vmax]);
set(gca,'TickDir','out');
hold off;

    end

    end   %end of if elev
  


     else
       xma=xmax;
       xmi=xmin;
       zma=zmax;
       zmi=zmin;
       if (x>xma) 
          xmax=xmax+xrange-1;
          xmin=xmin+xrange-1;
       end
       if (x<xmi)
          xmax=xmax+1-xrange;
          xmin=xmin+1-xrange;
       end
       if (z>zma)
          zmax=zmax+zrange-0.5;
          zmin=zmin+zrange-0.5;
       end
       if (z<zmi)
          zmax=zmax+0.5-zrange;
          zmin=zmin+0.5-zrange;
       end

%Display source data
clf;
axis([xmin xmax zmin zmax]);
hold on;
title(['Left button deletes. Right updates/fills in. Middle exits. Click outside axes to move']);
pcolor(X,Z,v);
caxis([vmin vmax]);
set(gca,'TickDir','out');
hold off;

     end
    

end   %end of while

disp(['don`t forget to change variables (eg v2=v)']);









