% produces a profile of Doppler spectra

if ~exist('spec')
disp('Doing Fourier transform...')
[n m]=size(hc);
Welch=(1-(([1:n]-n/2)./(n/2)).^2)'*ones(1,m);
s=n/128;
%s=n/64;

P=fft(hc.*Welch);
PPP=P.*conj(P);

clear P

%% AVERAGING!!
%disp('Averaging...')

%if n>32767
%s=512;
%end

PP=ave(PPP,s);

P=fft(vc.*Welch);
PPP=P.*conj(P);

clear P

PP=(PP+ave(PPP,s))./2;

clear Welch PPP


end

disp('Plotting...')
%haxis=[0 3];
%vaxis=[-5 5];

PRF=2688;
lambda=0.0086;
%NOTE factor of 0.5 in vfold calc is due to using h and v time series separately; effective PRF is halved
vfold=0.5*PRF.*lambda./4;
[n m]=size(PP);
spec=PP([n/2+1:n 1:n/2+1],:);
v=-vfold:2.*vfold/n:vfold;

offsetscale=2;%0.75;
%dBperkm=120/diff(rangein([1 2]));

hview=[1:1:m];
noisegate=m;
index=find(v>0.25|v<-0.25);
noise=mean(spec(index,noisegate));
stdn=std(spec(index',noisegate));
index=find(spec<noise+4*stdn);
tspec=spec-noise;
tspec(index)=NaN.*ones(size(index));

rangegate = [-0.1:0.075:15];
rangenew=rangegate(rangein);

%heightoffset=ones(n+1,1)*10.^(offsetscale*[1:m]);
heightoffset=ones(n+1,1)*rangenew*dBperkm;


%rangenew=range;
clf
set(gcf,'DefaultAxesFontSize',12)
axes('position',[0.1 0.1 0.4 0.8])
plot(v,10.*log10(spec(:,hview)./noise)+heightoffset(:,hview),'k');
%hold on
%plot(v,10.*log10(tspec(:,hview).*heightoffset(:,hview)),'b');

%hold on
%semilogy([-vfold vfold],(10.^(offsetscale*hview))'*[noise noise],'--');
for ii=hview
   if 10.*log10(mean(spec(1:10,ii))./noise)+heightoffset(1,ii)+dBperkm*0.03 < haxis(2).*dBperkm
      text(vaxis(1)+0.5,10.*log10(mean(spec(1:10,ii))./noise)+heightoffset(1,ii)+dBperkm*0.03,['{\bf' num2str(rangein(ii)) '.} ' num2str(rangenew(ii),3) ' km'],'FontSize',8);
   end
end
xlabel('Velocity (m/s)')
ylabel('Relative power (dB)')
title(['{\bf35 GHz} ' num2str(size(hc,1)) ' pt FFTs of H&V (' num2str(size(uc,1)/PRF,3) 's dwell), ' num2str(s*2) ' pt averaging'],'FontSize',10);
% -> ' num2str(4.343/sqrt(s),2) ' dB error, ' num2str(100.*2.*vfold/n,2) ' cm/s resolution'],'FontSize',10) 
set(gca,'XTick',[-7:7])
axis([vaxis haxis.*dBperkm]);
hold on
plot([0 0],[haxis.*dBperkm],'k:')

if 1
axes('position',[0.56 0.1 0.4 0.8])

plot(10.*log10(zmean./zmean(noisegate)),rangenew,'k')
xlabel('Signal-to-noise ratio (dB)')
ylabel('Height (km)')
axis([SNRaxis haxis])
hold on
plot([0 0],[-1 3],'k:')

end

spec35=spec;zmean35=zmean;rangenew35=rangenew;v35=v;noise35=noise;noisegate35=noisegate;
save /tmp/ts35 spec35 zmean35 rangenew35 v35 noise35 noisegate35


