function vs=smooth2(v,small)

%smooth2(v,small): Smooths v using 9-point average
% Use: vs=smooth2(v,small)
% small is the degree of smoothing (ie the relative contribution from each
% surrounding point, relative to the central point.

disp('Use smooth2d instead! (anisotropic smoothing)');

[mm nn]=size(v);
vs=v;
if small~=0
 n=2:(nn-1);
 m=2:mm-1;
	vs(m,n)=(v(m,n)+small*(v(m-1,n)+v(m+1,n)+v(m-1,n-1)+v(m,n-1)+v(m+1,n-1)+v(m-1,n+1)+v(m,n+1)+v(m+1,n+1)))/(1.+8.*small);
	vs(1,n)=(v(1,n)+small*(v(1+1,n)+v(1,n-1)+v(1+1,n-1)+v(1,n+1)+v(1+1,n+1)))/(1.+5.*small);
	vs(mm,n)=(v(mm,n)+small*(v(mm-1,n)+v(mm,n-1)+v(mm-1,n-1)+v(1,n+1)+v(mm-1,n+1)))/(1.+5.*small);
	vs(m,1)=(v(m,1)+small*(v(m-1,2)+v(m,2)+v(m+1,2)+v(m-1,1)+v(m+1,1)))/(1.+5.*small);
	vs(m,nn)=(v(m,nn)+small*(v(m-1,nn-1)+v(m,nn-1)+v(m+1,nn-1)+v(m-1,nn)+v(m+1,nn)))/(1.+5.*small);
	vs(1,1)=(v(1,1)+small*(v(1,2)+v(2,2)+v(2,1)))/(1.+3.*small);
	vs(mm,1)=(v(mm,1)+small*(v(mm,2)+v(mm-1,2)+v(mm-1,1)))/(1.+3.*small);
	vs(1,nn)=(v(1,nn)+small*(v(1,nn-1)+v(2,nn-1)+v(2,nn)))/(1.+3.*small);
	vs(mm,nn)=(v(mm,nn)+small*(v(mm-1,nn)+v(mm-1,nn-1)+v(mm,nn-1)))/(1.+3.*small);

 numnan=zeros(size(v));
 numnan(m,n)=isnan(v(m-1,n+1))+isnan(v(m,n+1))+isnan(v(m+1,n+1))+isnan(v(m-1,n))+isnan(v(m+1,n))+isnan(v(m-1,n-1))+isnan(v(m,n-1))+isnan(v(m+1,n-1));
 index=find(numnan ~= 0);
if ~isempty(index)
 vs(index)=v(index);
end
else
  vs=v;
end
